/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package web.gfc_client_ws;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Map;
import java.util.Properties;
import javax.xml.ws.BindingProvider;
import org.adullact.webgfc._1.MessageRetour;
import org.adullact.webgfc._1.WebgfcPort;
import org.adullact.webgfc._1.WebgfcService;

/**
 *
 * @author ssampaio
 */
public class WebGFC_client_ws {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws FileNotFoundException, IOException {
		//Declarations
		WebgfcService service;
		WebgfcPort port;
		FileInputStream MyInputStream;
		String webgfcUsername;
		String webgfcPassword;
		String webgfcServerUrl;
		String collectiviteId;
		Properties myProps = new Properties();

		//recupération des infos dans webgfc.properties
		MyInputStream = new FileInputStream("webgfc.properties");
		myProps.load(MyInputStream);
		collectiviteId = myProps.getProperty("collectivite_id");
		webgfcUsername = myProps.getProperty("username");
		webgfcPassword = myProps.getProperty("password");
		webgfcServerUrl = myProps.getProperty("webgfcServerUrl");
		//affichage des propriétés récupérées
		System.out.println("Paramètres utilisés : ");
		myProps.list(System.out);
		//fermeture du flux (fichier webgfc.properties)
		MyInputStream.close();

		try {
			//intialisation
			service = new WebgfcService();
			port = service.getWebgfcPort();

			//Header pour basic auth
			Map requestContext = ((BindingProvider) port).getRequestContext();
			requestContext.put(BindingProvider.USERNAME_PROPERTY, webgfcUsername);
			requestContext.put(BindingProvider.PASSWORD_PROPERTY, webgfcPassword);
			requestContext.put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, webgfcServerUrl + "/webservices/service");

			//test de scanMass
			System.out.println("Fichier utilisé : ");
			System.out.println(args[0]);


//			System.out.println("echotest :");
//			String getEchotestResp = port.echotest("test client");
//			System.out.println(getEchotestResp);

			System.out.println("Envoi : ");
			File fileToSend = new File(args[0]);
			MessageRetour getScanMassResp = port.scanMass(Integer.parseInt(collectiviteId), ImageToByte(fileToSend), webgfcUsername);
			System.out.println(getScanMassResp.getCodeRetour());
			System.out.println(getScanMassResp.getCourrierId());
			System.out.println(getScanMassResp.getSeverite());
			System.out.println(getScanMassResp.getMessage());
		} catch (NumberFormatException  e) {
			System.out.println(e.getCause());
			System.out.println(e.getClass());
			System.out.println(e.getMessage());
		}

	}

	public static byte[] ImageToByte(File file) throws FileNotFoundException, IOException {
		FileInputStream fis = new FileInputStream(file);
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		byte[] buf = new byte[1024];
		try {
			for (int readNum; (readNum = fis.read(buf)) != -1;) {
				bos.write(buf, 0, readNum);
				System.out.println("read " + readNum + " bytes,");
			}
		} catch (IOException ex) {
		}
		byte[] bytes = bos.toByteArray();

		return bytes;
	}
}
