# Change Log

Toutes les modifications apportées au projet seront documentées dans ce fichier.

Le format est basé sur le modèle [Keep a Changelog](http://keepachangelog.com/) 
et adhère aux principes du [Semantic Versioning](http://semver.org/).

## [2.0.3] - 2018-05-31
### Ajouts
- Ajout pour l'administrateur (uniquement) de la possibilité de ré-affecter le flux à un autre agent tant qu'il n'est pas inséré dans un circuit. 
- Ajout du champ Pays pour les formulaires de contacts et d'organismes
- Ajout d'une table de journalisation permettant de stocker les actions des utilisateurs. Consultation, édition, ajout, suppression sont stockées dans une table journalevents où le nom de l'utilisateur, l'action, le n° de référence, l'Id du courrier ... sont stockés
- Dans le cas où l'on refuse un flux, si on souhaite que le mail de refus ne soit adressé qu'à l'initiateur, il faudra désormais utiliser la variable Configure::write('Refus.InitiateurOnly', false); pour dire si on adresse seulement l'initiateur ou tous les agents concernés par le flux

### Corrections
- Ajout d'un nouveau patch SQL 2.0.3 qui corrige des soucis de la version 2.0.2
- Correction des filtres sur les champs _date_ qui cassaient lors du passage de page en page.
- Correction de la recherche disponible au niveau des bannettes d'historique
- Correction du bloc des commentaires qui disparaissait lorsque des -retour chariot_ étaient présents dans le texte
- Correction (SAERP) le calcul des OS entrants n'est plus pris en compte pur les marchés
- Correction lors de l'envoi d'un document (notamment l'AR) par mail depuis la partie Documents, une erreur apparaissait car la librairie XML_RPC2CLient n'était pas chargée
- Correction de la génération de l'AR
- Correction de la modification d'un organisme depuis la gestion du flux

### Évolutions
- Si un Aiguilleur possède également le profil Initiateur, à l'accès au flux, on l'autorise à insérer le flux dans le circuit lorsqu'il choisit le type/sous-type, s'il le souhaite. S'il ne possède pas de profil Initiateur, il ne peut toujours pas insérer dans le circuit
- Classement par ordre alphabétique des contacts suite à une recherche
- Seuls les administrateurs peuvent supprimer les carnets d'adresse, les organismes et les contacts
- Lorsque l'on clique sur les étoiles présentes sur chacun des intitulés de blocs présents dans la gestion du flux, on masque/affiche les informations présentes. Cela permettra aux agents de réduire les données à l'affichage
- Suite au ticket #2014830: ajout de la possibilité d'activer/désactiver un contact (+ les organismes)
- L'administrateur a désormais la possibilité de pousser un flux 'bloqué' à une étape donnée depuis la gestion du flux. Via la recherche, on trouve le flux, on le consulte, on l'édite et les actions d'insertion et/ou envoi à une étape suivante sont disponibles et effectives.
- Le nom du sous-type sélectionné côté i-Parapheur est désormais affcihé à l'étape i-Parapheur
- Dans le paramétrage des bureaux, ajout d'une colonne reprenant la liste des profils associés au bureau en question
- Amélioration du temps de chargement des informations du flux en édition avec déplacement des fonctions permettant de vérifier si les dates présentes sont bonnes

## [2.0.2] - 2017-11-28
### Corrections
- Correction du versement en GED depuis la gestion du flux
- Ajout d'un nouveau patch SQL 2.0.2 qui corrige des soucis de la version 2.0.1 (renommage de séquence et contrainte)
- Correction de l'envoi par mails des ARs
- Correction si le flux ne possède pas de type/sous-type, il ne ressortait pas dans la recherche
- Correction (SAERP) le format de la date du premier mois dans les marchés n'était pas bon
- Correction pour l'ajout d'un nouveau profil qui posait souci à cause de l'intitulé Rôle automatiquement chargé

### Évolutions
- Redimensionnement du menu du haut selon la taille 1600*900
- Modification du niveau de détection des homonymes avec abaissement du niveau à < en lieu et place de <= car il y avait des faux-positifs
- Sauvegarde automatique pour les éléments des méta-données d'un flux
- Suppression de la visualisation d'un contact car non utilisée


## [2.0.1] - 2017-10-31
### Corrections
- Correction de l'action de suppression d'un organisme
- Correction sur le champ objet de la partie commentaire "cassait" le javascript ce qui bloquait l'affichage de la liste des commentaires
- Correction pour la SAERP, les OS entrants étaient pris en compte dans le calcul du nombre d'OS pour un marché, ce qui n'est plus le cas
- Correction de la mise en place d'une délégation planifiée
- Correction de l'écran de modification d'un type/sous-type
- Correction du script d'intégration des contacts dans les carnets d'adresse
- Correction des exports CSV issus de la recherche (par commentaires, par types/sous-types, par contacts ...)

### Évolutions
- Amélioration de la gestion des erreurs lors d'une connexion au i-Parapheur
- Ajout de l'affichage du sous-type défini dans le i-Parapheur pour l'étape i-Parapheur du circuit de traitement d'un flux
- Changement des dates dans le footer par 2006-2018 
- Ajout du nom de l'organisme lorsque l'on accède à la liste des contacts liés à un organisme
- Suppression de l'action _Supprimer_ pour les connecteurs d'une collectivité
- Remplacement des intitulés Clôturer/Clôturé(s) en Clore/Clos


## [2.0] - 2017-08-30
### Ajouts
- Ajout d'un outil statistiques externe complet
- Ajout d'un système d'abonnement aux notifications de façon quotidienne ou à chaque évènement
- Ajout d'un scrip afin de 
- Ajout de l'enregistrement automatique des informations dans la gestion du flux
- Ajout de la possibilité de naviguer d'un flux à un autre directement depuis la gestion d'un flux
- Ajout pour TOUS les modèles ODT d'une action d'édition (via webdav)
- Ajout de la possibilité d'activer/désactiver un service, un type et un sous-type
- Ajout du champ e-mail pour les services
- Ajout des adresses mails des contacts lors de l'envoi d'un document par mail 
- Ajout de la possibilité d'adresser plusieurs documents (document principal et/ou ses pièces jointes) lors de l'envoi d'un mail

### Évolutions
- Evolution pour prendre compte la distribution Linux Ubuntu LTS 16.04 de base 
- Evolution prise en charge de php en version 7 
- Evolution prise en charge de postgresql en version 9.5 
- Evolution de l'ergonomie de l'application avec la mise en œuvre de Bootstrap v3.0
- Evolution de la prévisualisation des documents avec un passage sous Pdf.js
- Evolution du versement en GED qui est désormais complet
- Evolution pour l'aiguilleur qui peut désormais consulter les documents scannés directement depuis son environnement
- Evolution du formulaire de recherche

## [2.0-beta2] - 2017-05-31
### Ajouts
- Début de la mise en place de la charte graphique Libriciel SCOP
- Système d'abonnement aux notifications (Résumé journalier ou à chaque événement)
- Possibilité d'envoyer plusieurs documents par mail
- Ajout d'un email pour les services de la collectivité

### Corrections
- Chargement des types et sous-types
- Le CSS et le javascript ont été changés suite à la mise ne oeuvre de la charte graphique Libriciel SCOP

### Évolutions
- Tableau de suivi du cycle de vie du flux: mise ne place d'icône pour les entêtes de colonnes
- Déplacement des chargements des listes déroulantes dans le controller plutôt que dnas la vue (organismes, contacts, types/sous-types)


## [2.0-beta] - 2017-05-02
### Ajouts
- Navigation entre les différents flux depuis la gestion d'un flux

### Corrections
- Lors de la génération de réponse, si + d'1 document webdav est utilisé, la fusion reprend les données de chacun des fichiers renseignés
- Les observations sur les contacts possédant des caractères spéciaux (`\, /, "` ...) faisaient "casser" le javascript

### Évolutions
- La visionneuse Flash est remplacée par une visionneuse sous PDF.js


## [2.0-alpha] - 2016-09-01 / 2017-05-01
### Ajouts
- Refonte totale de l'ergonomique de web-GFC



[2.0]: https://gitlab.libriciel.fr/web-GFC/webgfc

