<?php

/**
 *
 * Courriers/set_infos.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
if (!empty($newCourrierId)) {
    echo $newCourrierId;
} else {
    echo $this->Html->script('formValidate.js', array('inline' => true));
    echo $this->Html->script('contactinfo.js', array('inline' => true));
?>
<script>
    function addslashes(ch) {
        ch = ch.replace(/\\/g, "\\\\")
        ch = ch.replace(/\'/g, "\\'")
        ch = ch.replace(/\"/g, "\\\"")
        return ch
    }

    function refreshOrganismes(orgInfos) {
        $("#CourrierOrganismeId").append($("<option value='" + orgInfos['id'] + "'>" + orgInfos['name'] + "</option>"));
        $('#CourrierOrganismeId').val(orgInfos['id']).change();
        if (typeof orgInfos['contacts']['id'] !== 'undefined') {
            refreshContact(orgInfos); //FIXME
        }
    }

    function refreshContact(contactinfo) {
        $("#CourrierContactId").append($("<option value='" + contactinfo['contacts']['id'] + "'>" + contactinfo['contacts']['name'] + "</option>"));
        $('#CourrierContactId').val(contactinfo['contacts']['id']).change();
        refreshContactInfos(contactinfo['contacts']['id']);
    }

    function refreshContactInfos(contactId) {
        if (contactId != '' && contactId != null) {
            $("[id^=contactInfoCard]").remove();
            gui.request({
                url: '/contacts/searchContactinfo/' + contactId
            }, function (data) {
                $('#CourrierContactId').val(contactId);
                var json = jQuery.parseJSON(data);
                var contactinfo = json['Contactinfo'];
                if (typeof contactinfo['id'] !== 'undefined') {
                    $('#CourrierContactId').bind('change', showContactinfo()).parent().append(createContactinfo(contactinfo));
                }
                $('#contactInfoCard' + contactId).show();
            });
        } else {
            $("[id^=contactInfoCard]").hide();
        }
    }

    function refreshOrganismeInfos(organismeId) {
        gui.request({
            url: '/contacts/searchOrganismeinfo/' + organismeId
        }, function (data) {
            $('.organismeInfoCard').remove();
            $('#CourrierOrganismeId').val(organismeId);
            var json = jQuery.parseJSON(data);
            var organismeinfo = json['Organisme'];
            if (typeof organismeinfo['id'] !== 'undefined') {
                $('#CourrierOrganismeId')
                        .bind('change', showOrganismeinfo())
                        .parent().append(createOrganismeinfo(organismeinfo));
            }
            $('#organismeInfoCard' + $('#CourrierOrganismeId option:selected').val()).show();
        });
    }

    function genPriorityImg() {
        var img = $('<img />').attr('id', 'priorityImg').css({
            width: '16px',
            height: '16px',
            "vertical-align": "middle",
            margin: "-25px -25px auto auto",
            float: "right"
        });

        var priorityLevel = $('#CourrierPriorite option:selected').val();
        if (priorityLevel == 0) {
            img.attr('src', '/img/priority_low.png');
        } else if (priorityLevel == 1) {
            img.attr('src', '/img/priority_mid.png');
        } else if (priorityLevel == 2) {
            img.attr('src', '/img/priority_high.png');
        }

        $('#CourrierPriorite').after(img);
    }


    function gestionWidthPanel() {
        if ($(window).width() < 1100) {
            $('#flux_infos >.panel.col-sm-11 .panel.col-sm-6').removeClass('col-sm-6').addClass('col-sm-12');
        } else {
            $('#flux_infos >.panel.col-sm-11 .panel.col-sm-12').removeClass('col-sm-12').addClass('col-sm-6');
        }
    }

    function chargementOptionsContact() {
        var courrierOrganismedIdVal = $("#CourrierOrganismeId").val();
        var contactLists = <?php echo json_encode($contactOptions); ?>;
        if (contactLists[courrierOrganismedIdVal] != undefined) {
            var tempContactOptions = [];
            var i = 0;
            $.each(contactLists[courrierOrganismedIdVal], function (index, value) {
                tempContactOptions[i] = {
                    'key': index,
                    'val': value
                };
                i++;
            });
            var ContactOptions = tempContactOptions.sort(function (a, b) {
                return a.val.localeCompare(b.val);
            });
            $('#CourrierContactId option').remove();
            $('.contactInfoCard').remove();
            $.each(ContactOptions, function (index, value) {
                $('#CourrierContactId').append($("<option value='" + value.key + "'>" + value.val + "</option>"));
            });
        }
    }
</script>
<?php
$url = array('controller' => 'courriers', 'action' => 'createInfos');
if (isset($this->data['Courrier']['id'])) {
  $url[] = $this->data['Courrier']['id'];
}

$tabDelaiUnite = array(
    0 => 'jour',
    1 => 'semaine',
    2 => 'mois'
);
$priorites = array(
  0 => __d('courrier', 'Courrier.priorite_basse'),
  1 => __d('courrier', 'Courrier.priorite_moyenne'),
  2 => __d('courrier', 'Courrier.priorite_haute')
  );
$formCourrier = array(
    'name' => 'Courrier',
    'label_w' => 'col-sm-3',
    'input_w' => 'col-sm-5',
    'input' => array(
        'Courrier.id' => array(
            'inputType' => 'hidden',
            'items'=>array(
                'type'=>'hidden'
            )
        )
    )
);
echo $this->Formulaire->createForm($formCourrier);
?>

<div class="row">
    <?php
    
$formCourrierFlux = array(
        'name' => 'Courrier',
        'label_w' => 'col-sm-4',
        'input_w' => 'col-sm-8',
        'form_url' => $url,
        'input' => array(
            'Courrier.id' => array(
                'inputType' => 'hidden',
                'items'=>array(
                    'type'=>'hidden'
                )
            )
        )
    );
    $formCourrierFlux['input']['Courrier.name'] =array(
        'labelText' =>__d('courrier', 'Courrier.name'),
        'inputType' => 'text',
        'items'=>array(
            'required'=>true,
            'type'=>'text'
        )
    );
    $formCourrierFlux['input']['Courrier.origineflux_id'] =array(
        'labelText' =>__d('courrier', 'Courrier.origineflux_id'),
        'inputType' => 'select',
        'items'=>array(
            'type' => 'select', 
            'options' => $origineflux, 
            'empty' => true
        )
    );
    $formCourrierFlux['input']['Courrier.direction'] =array(
        'labelText' =>__d('courrier', 'Courrier.direction'),
        'inputType' => 'hidden',
        'items'=>array(
            'type'=>'hidden'
        )
    );
    $formCourrierFlux['input']['Courrier.objet'] =array(
        'labelText' =>__d('courrier', 'Courrier.objet'),
        'inputType' => 'textarea',
        'items'=>array(
            'type'=>'textarea'
        )
    );
    $formCourrierFlux['input']['Courrier.priorite'] =array(
        'labelText' =>__d('courrier', 'Courrier.priorite'),
        'inputType' => 'select',
        'items'=>array(
            'type' => 'select', 
            'options' => $priorites, 
            'default' => 0
        )
    );
    if( !Configure::read('Conf.SAERP') ) {
        $formCourrierFlux['input']['Courrier.affairesuiviepar_id'] = array(
            'labelText' => __d('courrier', 'Courrier.affairesuiviepar_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                'options' => $allDesktops, 
                'empty' => true
            )
        );
    }
    ?>
    <div class="col-sm-6">
        <legend><?php echo  __d('courrier', 'Courrier.fluxFieldset'); ?></legend>
        <div  class="panel-body  form-horizontal" >
            <?php echo $this->Formulaire->createForm($formCourrierFlux); ?>
        </div>
    </div>
    <?php 
    //réalisation des formulaire du parite Qualification
        $soustypeDelaiNb = (isset($this->data['Soustype']['delai_nb'])) ? $this->data['Soustype']['delai_nb']  : null;
        $soustypeDelaiUnite = (isset($this->data['Soustype']['delai_unite'])) ? $this->data['Soustype']['delai_unite']  : null;
        $formCourrierQualification = array(
            'name' => 'Courrier',
            'label_w' => 'col-sm-5',
            'input_w' => 'col-sm-6',
            'input' => array(
                'Courrier.id' => array(
                    'inputType' => 'hidden',
                    'items'=>array(
                        'type'=>'hidden'
                    )
                )
            )
        );

    if( Configure::read('Conf.SAERP') ) {
        $formCourrierQualification['input']['Courrier.typedocument'] =array(
            'labelText' =>__d('courrier', 'Courrier.typedocument'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => $typesdocument,
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Courrier.marche_id'] =array(
            'labelText' =>__d('courrier', 'Courrier.marche_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => !empty($marches)? $marches: array(), 
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Courrier.consultation_id'] =array(
            'labelText' =>__d('courrier', 'Courrier.consultation_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => $consultations,
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Ordreservice.numero'] =array(
            'labelText' =>__d('ordreservice', 'Ordreservice.numero'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Ordreservice.objet'] =array(
            'labelText' =>__d('ordreservice', 'Ordreservice.objet'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Ordreservice.montant'] =array(
            'labelText' =>__d('ordreservice', 'Ordreservice.montant'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Ordreservice.marche_id'] =array(
            'inputType' => 'hidden',
            'items'=>array(
                'type' => 'hidden'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.origineflux_id'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.origineflux_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select',
                'empty' => true,
                'options' => $origineflux
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.numero'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.numero'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.lot'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.lot'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.objet'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.objet'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.date'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.date'),
            'inputType' => 'text',
            'dateInput' =>true,
            'items'=>array(
                'type' => 'text',
                'class' => 'datepickerPli',
                'readonly' => true,
                'data-format'=>'dd/mm/yyyy'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.marche_id'] =array(
            'inputType' => 'hidden',
            'items'=>array(
                'type' => 'hidden'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.heure'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.heure'),
            'inputType' => 'time',
            'items'=>array(
                'type' => 'time',
                'timeFormat' => '24',
                'interval' => 05,
                'empty' => true
            )
        );  
    }
        $formCourrierQualification['input']['Types.Type'] = array(
            'labelText' =>__d('type', 'Type'),
            'inputType' => 'select',
            'items'=>array(
                'type'=>'select',
//                "options" => array(), 
//                "options" =>$typeOptions, 
                'disabled' => $isInCircuit ? 'disabled' : '', 
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Courrier.soustype_id'] = array(
            'labelText' =>__d('soustype', 'Soustype'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => array(), 
                'disabled' => $isInCircuit ? 'disabled' : '', 
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Courrier.reference'] = array(
            'labelText' =>__d('courrier', 'Courrier.reference'),
            'inputType' => 'text',
            'items'=>array(
                'type'=>'text',
                'readonly' => true,
                'class' => 'fakeDisabledInputText'
            )
        );
        $formCourrierQualification['input']['Courrier.entrant'] = array(
            'labelText' =>__d('courrier', 'Courrier.entrant/sortant'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text',
                'readonly' => true,
                'class' => 'fakeDisabledInputText'
            )
        );
        $formCourrierQualification['input']['Courrier.delai_nb'] = array(
            'labelText' =>'Délai de traitement',
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text', 
                'empty' => true,
                'class' =>'fakeDisabledInputText',
//                'readonly' => true,
                'value' => $soustypeDelaiNb
            )
        );
        $formCourrierQualification['input']['Courrier.delai_unite'] = array(
            'labelText' =>false,
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                'options' => $tabDelaiUnite, 
                'value' => $soustypeDelaiUnite,
//                'readonly' => true, 
                'empty' => true,
                'class' => 'unitecreate '
            )
        );
    ?>
    <div class="col-sm-6">
        <legend><?php echo  __d('courrier', 'Qualification');?></legend>
        <div  class="panel-body  form-horizontal" >
                <?php echo $this->Formulaire->createForm($formCourrierQualification); ?>
        </div>
    </div>
</div>
<div class='row'>
    <?php 
    //réaliser les formulaire du parite de Contact
    $formCourrierContact = array(
        'name' => 'Courrier',
        'label_w' => 'col-sm-5',
        'input_w' => 'col-sm-6',
        'input' => array(
            'Courrier.organisme_id' => array(
                'inputType' => 'select',
                'labelText' =>__d('courrier', 'Courrier.contact'),
                'items'=>array(
                    'title'=>__d('courrier', 'Courrier.contact'),
                    'type'=>'select',
//                    'options' => array()
                    'options' =>$organismOptions
                )
            ),
            'Courrier.contact_id' => array(
                'inputType' => 'select',
                'labelText' =>__d('courrier', 'Courrier.contact_id'),
                'items'=>array(
                    'type'=>'select',
                    'options' => array()
//                    'options'=>$contactOptionsOrigine
                )
            )
        )
    );
    ?>
    <div class="col-sm-6">
        <legend><?php echo __d('courrier', 'Courrier.contactFieldset'); ?></legend>
        <div  class="panel-body  form-horizontal" >
                <?php echo $this->Formulaire->createForm($formCourrierContact); ?>
        </div>
    </div>
    <?php 
    //réaliser les formulaire du partie Date
        $formCourrierDate = array(
            'name' => 'Courrier',
            'label_w' => 'col-sm-5',
            'input_w' => 'col-sm-6',
            'input' => array(
                'Courrier.datereception' => array(
                    'inputType' => 'text',
                    'labelText' =>__d('courrier', 'Courrier.datereception'),
                    'dateInput' =>true,
                    'items'=>array(
                        'type'=>'text',
                        'readonly' => true,
                        'data-format'=>'dd/MM/yyyy'
                    )
                ),
                'Courrier.date' => array(
                    'inputType' => 'text',
                    'labelText' =>__d('courrier', 'Courrier.date'),
                    'dateInput' =>true,
                    'items'=>array(
                        'type'=>'select',
                        'readonly' => true,
                        'data-format'=>'dd/MM/yyyy'
                    )
                )
            )
        );
    ?>
    <div class="col-sm-6">
        <legend><?php echo  __d('courrier', 'Courrier.dateFieldset'); ?></legend>
        <div  class="panel-body  form-horizontal" >
                <?php echo $this->Formulaire->createForm($formCourrierDate); ?>
        </div>
    </div>
</div>
<?php
echo $this->Form->end();
?>

<script type="text/javascript">
    $('document').ready(function () {
        $('#CourrierName').prop('spellcheck', true);
            
        $('.form_datetime input').datepicker({
            language: 'fr-FR',
            format: "dd/mm/yyyy",
            weekStart: 1,
            autoclose: true,
            todayBtn: 'linked'
        });

        $(window).resize(function () {
            gestionWidthPanel();
        });
        gestionWidthPanel();

        $("#CourrierOrganismeId").select2({allowClear: true, placeholder: "Sélectionner un organisme"});
        $("#CourrierContactId").select2({allowClear: true, placeholder: "Sélectionner un contact"});
        $('#PliconsultatifHeureHour').select2({allowClear: true});
        $('#PliconsultatifHeureMin').select2({allowClear: true});

        $('select[name="data[Courrier][affairesuiviepar_id]"]').select2({allowClear: true, placeholder: "Sélectionner une personne"});
        $('select[name="data[Courrier][origineflux_id]"]').select2({allowClear: true, placeholder: "Sélectionner une origine"});
        $('select[name="data[Courrier][priorite]"]').select2({allowClear: true, placeholder: "Sélectionner une priorité"});

        $("#CourrierDelaiUnite").select2({allowClear: true, placeholder: "Sélectionner une unité"});

        $('#s2id_CourrierDelaiUnite').css({
            height: '0px',
            width: '46%',
            float: 'right',
            position: 'relative',
            top: '-52px'
        });


        $("#CourrierOrganismeId").val("<?php echo $sansOrganisme;?>").change();
        showOrganismeinfo();
        var organisme_id = $("#CourrierOrganismeId").val();
        if (organisme_id != '') {
            refreshOrganismeInfos(organisme_id);
        }

        chargementOptionsContact();
        $("#CourrierContactId").val("<?php echo $sansContact;?>").change();
        showContactinfo();
        if ($('#CourrierContactId').val() != '') {
            refreshContactInfos($('#CourrierContactId').val());
        }

    }
    );
    $('select[name="data[Types][Type]"]').select2({allowClear: true, placeholder: "Sélectionner un type"});
    $('select[name="data[Courrier][soustype_id]"]').select2({allowClear: true, placeholder: "Sélectionner un sous-type"});
    //contruction du tableau de types / soustypes
    ////contruction du tableau de types / soustypes
    <?php if (Configure::read('Use.AuthRights') && !Configure::read('Conf.SAERP')) :?>
            var types = [];
            <?php foreach ($types as $type) { ?>
            var type = {
                id: "<?php echo $type['Type']['id']; ?>",
                name: "<?php echo addslashes( $type['Type']['name'] ); ?>",
                soustypes: []
            };
                    <?php foreach ($type['Soustype'] as $stype) { ?>
            var soustype = {
                id: "<?php echo $stype['id']; ?>",
                name: "<?php echo addslashes( $stype['name'] ); ?>",
                entrant: "<?php echo $stype['entrant']; ?>"
            };
            type.soustypes.push(soustype);
                    <?php } ?>
            types.push(type);
            <?php } ?>
            function fillSoustypes(type_id, stype_id) {
                $("#CourrierSoustypeId").empty();
//                $("#CourrierSoustypeId").append($("<option value=''> --- </option>"));
                for (i in types) {
                    if (types[i].id == type_id) {
                        for (j in types[i].soustypes) {
                            if (types[i].soustypes[j].id == stype_id) {
                                $("#CourrierSoustypeId").append($("<option value='" + types[i].soustypes[j].id + "' selected='selected'>" + types[i].soustypes[j].name + "</option>"));
                            } else {
                                $("#CourrierSoustypeId").append($("<option value='" + types[i].soustypes[j].id + "'>" + types[i].soustypes[j].name + "</option>"));
                            }
                        }
                    }
                }
            }


//            $("#TypesType").append($("<option value=''> --- </option>"));
            //remplissage de la liste des types
            for (i in types) {
                $("#TypesType").append($("<option value='" + types[i].id + "'>" + types[i].name + "</option>"));
            }
            //definition de l action sur type
            $("#TypesType").bind('change', function () {
                var type_id = $('option:selected', this).attr('value');
                fillSoustypes(type_id);
            });
        <?php else :?>
            $('#TypesType').change(function () {
                var type_id = $(this).val();
                var soustypeLists = <?php echo json_encode($soustypeOptions); ?>;
                $('#CourrierSoustypeId option').remove();

                // On est obligés de passer par un array car on ne peut trier les clés d'un objet
                var options = [];
                for (var value in soustypeLists[type_id]) {
                    options.push([value, soustypeLists[type_id][value]]);
                }
                options.sort(function(a, b) {
                    if(a[1] < b[1]) return -1;
                    else if(a[1] > b[1]) return 1;
                    return 0;
                });

                $.each(options, function (index, value) {
                    $('#CourrierSoustypeId').append($("<option value='" + value[0] + "'>" + value[1] + "</option>"));
                });
            });
        <?php endif;?>

    $("#CourrierContactId").change(function () {
        showContactinfo();
        if ($('#CourrierContactId').val() != '') {
            refreshContactInfos($('#CourrierContactId').val());
        }
    });

    function setFieldSetContact(stypeId) {
        if (stypeId == -1) {
            $('#fieldsetContact').css('display', 'none');
        } else if (stypeId == 0) {
            //				$('#fieldsetContact').hide('fast');
        } else {
            $('#fieldsetContact').show('slow');
            var sens;
            for (i in types) {
                for (j in types[i].soustypes) {
                    if (types[i].soustypes[j].id == stypeId) {
                        sens = types[i].soustypes[j].entrant;
                    }
                }
            }
            if (sens == 1 || sens == 2) {
                $('#fieldsetContact .panel-heading h4').html("<?php echo __d('courrier', 'Courrier.contactFieldset.exp'); ?>");
                $('#fieldsetContact label[for=CourrierContactName]').html("<?php echo __d('courrier', 'Courrier.contact.exp'); ?>");
                $('#fieldsetContact label[for=CourrierContact]').html("<?php echo __d('courrier', 'Courrier.contactinfo.exp'); ?>");
            } else if (sens == 0) {
                $('#fieldsetContact .panel-heading h4').html("<?php echo __d('courrier', 'Courrier.contactFieldset.dest'); ?>");
                $('#fieldsetContact label[for=CourrierContactName]').html("<?php echo __d('courrier', 'Courrier.contact.dest'); ?>");
                $('#fieldsetContact label[for=CourrierContact]').html("<?php echo __d('courrier', 'Courrier.contactinfo.dest'); ?>");
            }
        }
    }

    //definition de l action sur stype
    $("#CourrierSoustypeId").bind('change', function () {
        var stype_id = $('option:selected', this).attr('value');
        $('.msgChange').remove();
        var reloadImgString = '<?php echo $this->Html->image('/img/reload.png'); ?>';
        var reloadImgFullString = '<?php echo $this->Html->image('/img/reload.png', array('alt' => __d('courrier', 'Courrier.messagechange.short'), 'title' => __d('courrier', 'Courrier.messagechange'))); ?>';
        $('.fakeDisabledInputText').after($('<span></span>').addClass('msgChange').html(reloadImgString + ' ' + "<?php echo __d('courrier', 'Courrier.messagechange'); ?>"));
        $('#delai').after($('<div></div>').addClass('msgChange').html(reloadImgString + ' ' + "<?php echo __d('courrier', 'Courrier.messagechange'); ?>"));
        $('.context_accordion .ui-accordion-header').each(function () {
            if ($('a', this).length > 0) {
                $(this).append($('<span></span>').addClass('msgChange').html(reloadImgFullString));
            }
        });
        $('.unitecreate').css({top: '-66px'});
    });





    $('#CourrierPriorite').change(function () {
        $('#priorityImg').remove();
        genPriorityImg();
    });
    genPriorityImg();

 <?php if( Configure::read('Conf.SAERP')) :?>
    $(document).ready(function () {
        $("<div id='ordreservice'>").insertBefore($('#OrdreserviceNumero').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceNumero').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceObjet').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceMontant').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceMarcheId'));

        $("<div id='pliconsultatif'>").insertBefore($('#PliconsultatifOriginefluxId').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifOriginefluxId').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifNumero').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifLot').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifObjet').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifDate').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifHeureHour').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifMarcheId'));


        $("<div id='marche'>").insertBefore($('#CourrierMarcheId').parents('.form-group'));
        $("#marche").append($('#CourrierMarcheId').parents('.form-group'));

        $("<div id='consult'>").insertBefore($('#CourrierConsultationId').parents('.form-group'));
        $("#consult").append($('#CourrierConsultationId').parents('.form-group'));

    });

    $('#PliconsultatifOriginefluxId').select2({allowClear: true, placeholder: "Sélectionner un mode de réception"});
    $('#PliconsultatifHeureHour').select2({allowClear: true});
    $('#PliconsultatifHeureMin').select2({allowClear: true});
    $("#CourrierConsultationId").select2({allowClear: true, placeholder: "Sélectionner une consultation"});
    $("#CourrierMarcheId").select2({allowClear: true, placeholder: "Sélectionner un marché"});
    $("#CourrierTypedocument").select2({allowClear: true, placeholder: "Sélectionner un type de document"});
    $('#ordreservice').hide();
    $('#pliconsultatif').hide();
    $('#consult').hide();
    $('#marche').hide();
    // Lors de lé selection du marché, on remplit le champ Type
    $('#CourrierMarcheId').change(function () {
        gui.request({
            url: "/courriers/ajaxformtype/marcheid",
            data: $('#CourrierCreateInfosForm').serialize()
        }, function (data) {
            processJsonFormCheck(data);
            $("#TypesType option").each(function () {
                if ($(this).attr('value') == $.trim(data)) {
                    $(this).attr('selected', 'selected').change();
                }
            });
        });
    });
    // Si le marché est sélectionné, on affiche les infos de l'OS et on calcule le numéro de l'OS
    // on sélectionne le type
    $('#CourrierTypedocument').change(function () {
        var marcheid = $('#CourrierMarcheId').val();
        var consultationId = $('#CourrierConsultationId').val();
        if ($('#CourrierTypedocument').val() == 'OS') {
            // SI c'es tun OS, on affiche les infos
            $('#ordreservice').show();
            $('#consult').hide();
            $('#marche').show();
            $('#pliconsultatif').hide();
            // SI c'es tun OS, on calcule le numéro
            gui.request({
                url: "/ordresservices/ajaxformdata/typedocument/" + marcheid,
                data: $('#CourrierCreateInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#OrdreserviceNumero').val($.trim(data)).change();
            });
        }
        else if ($('#CourrierTypedocument').val() == 'PLI') {
            $('#ordreservice').hide();
            $('#consult').show();
            $('#marche').hide();
            $('#pliconsultatif').show();
            gui.request({
                url: "/plisconsultatifs/ajaxformdata/typedocument/" + consultationId,
                data: $('#CourrierCreateInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#PliconsultatifNumero').val($.trim(data)).change();
            });
        }
        else if ($('#CourrierTypedocument').val() == 'LN') {
            $('#ordreservice').hide();
            $('#consult').hide();
            $('#marche').show();
            $('#pliconsultatif').hide();
        }
        else if ($('#CourrierTypedocument').val() == 'LC') {
            $('#ordreservice').hide();
            $('#consult').hide();
            $('#marche').hide();
            $('#pliconsultatif').hide();
        }
        else {
            // sinon on masque les infos
            $('#ordreservice').hide();
            $('#pliconsultatif').hide();
            $('#consult').hide();
            $('#marche').hide();
        }
    });
    if ($('#CourrierTypedocument').val() == 'OS') {
        $('#ordreservice').show();
        $('#pliconsultatif').hide();
        $('#consult').hide();
        $('#marche').show();
    }
    else if ($('#CourrierTypedocument').val() == 'PLI') {
        $('#ordreservice').hide();
        $('#pliconsultatif').show();
        $('#consult').show();
        $('#marche').hide();
    }
    else if ($('#CourrierTypedocument').val() == 'LN') {
        $('#ordreservice').hide();
        $('#consult').hide();
        $('#marche').show();
        $('#pliconsultatif').hide();
    }
    else if ($('#CourrierTypedocument').val() == 'LC') {
        $('#ordreservice').hide();
        $('#consult').hide();
        $('#marche').hide();
        $('#pliconsultatif').hide();
    }
    else {
        $('#ordreservice').hide();
        $('#pliconsultatif').hide();
        $('#consult').hide();
        $('#marche').hide();
    }

    // Si on modifie le marché
    $('#CourrierMarcheId').change(function () {
        // Si c'st un OS
        if ($('#CourrierTypedocument').val() == 'OS') {
            var marcheid = $('#CourrierMarcheId').val();
            // on recalcule le numéro de l'OS
            gui.request({
                url: "/ordresservices/ajaxformdata/typedocument/" + marcheid,
                data: $('#CourrierCreateInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#OrdreserviceNumero').val($.trim(data)).change();
            });

            $('#OrdreserviceNumero').change(function () {
                checkExists();
            });
        }
    });
    $('#CourrierConsultationId').change(function () {
        // sinon Si c'st un pli
        if ($('#CourrierTypedocument').val() == 'PLI') {
            var consultationId = $('#CourrierConsultationId').val();
            // on recalcule le numéro du pli
            gui.request({
                url: "/plisconsultatifs/ajaxformdata/typedocument/" + consultationId,
                data: $('#CourrierCreateInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#PliconsultatifNumero').val($.trim(data)).change();
            });
        }
    });
        <?php endif;?>

    //contruction du tableau de types / soustypes
    $('#CourrierOrganismeId').change(function () {
        showOrganismeinfo();
        showContactinfo();

        var organisme_id = $(this).val();
        if (organisme_id != '') {
            refreshOrganismeInfos(organisme_id);
        }
        chargementOptionsContact();
    });

// Actions pour la partie Organisme
<?php
//    $addOrganismeImg = $this->Html->image('/img/contact_add_16.png', array('id' => 'addOrganisme', 'name' => 'addOrganisme', 'title' => __d('organisme', 'Organisme.add')));
    $addOrganismeImg = '<i class="fa fa-plus-circle table" id=addOrganisme name=addOrganisme title="Ajouter un organisme"></i>';
?>
    var addOrganismeImg = $('<?php echo $addOrganismeImg; ?>').css({height: '16px', width: '16px', color: '#428bca', float: 'right', margin: '-42px -30px auto auto', cursor: 'pointer'}).click(function () {
//        $(".modal").empty();
        gui.formMessage({
            url: "/courriers/add_organisme",
            loader: true,
            updateElement: $('#addOrganisme').parents('fieldset'),
            loaderMessage: gui.loaderMessage,
            width: 600,
            buttons: {
                "<?php echo __d('default', 'Button.submit'); ?>": function () {
                    var form = $('#CourrierAddOrganismeForm');
                    if (form_validate(form)) {
                        gui.request({
                            url: form.attr('action'),
                            data: form.serialize()
                        }, function (data) {
                            orgInfos = jQuery.parseJSON(data);
                            layer.msg("Les informations ont bien été enregistrées");
                            refreshOrganismes(orgInfos);
                        });
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    } else {
                        swal({
                            title: "Oops...",
                            text: "Veuillez vérifier votre formulaire!",
                            type: "error",
                            timer: 1500
                        });
                    }
                },
                "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                    $(this).parents(".modal").modal('hide');
                    $(this).parents(".modal").empty();
                }
            }
        });
    }).appendTo($('#CourrierOrganismeId').parent());
    // Modification fiche contact
<?php
//$editOrganismeImg = $this->Html->image('/img/tool.png', array('id' => 'editOrganisme', 'name' => 'editOrganisme', 'title' => __d('organisme', 'Organisme.edit'))); 
$editOrganismeImg = '<i class="fa fa-pencil table" id=editOrganisme name=editOrganisme title="Modification"></i>';
?>

    var editOrganismeImg = $('<?php echo $editOrganismeImg; ?>').css({height: '16px', width: '16px', color: '#428bca', float: 'right', margin: '-42px -50px auto auto', cursor: 'pointer'}).click(function () {
        orgId = $('#CourrierOrganismeId').val();
//        contactId = $('#CourrierContactId').val();
//        if (contactId != '') {
//            url = "/courriers/edit_organisme/" + orgId + '/' + contactId;
//        }
//        else {
        url = "/courriers/edit_organisme/" + orgId;
//        }
        $(".modal").empty();
        if (orgId == "<?php echo $sansOrganisme; ?>") {
            var title = "<?php echo __d('organisme', 'Organisme.edit') ?>";
            var text = "<?php echo __d('organisme', 'Organisme.edit.forbidden') ?>";
            swal({
                title: 'Oops...',
                text: title + "<br>" + text,
                type: 'warning',
                timer: 1500
            });
        }
        else {

            gui.formMessage({
                url: url,
                loader: true,
                updateElement: $('#editOrganisme').parents('fieldset'),
                loaderMessage: gui.loaderMessage,
                width: 600,
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {
                        var form = $(this).parents('.modal').find('form');
                        if (form_validate(form)) {
                            gui.request({
                                url: form.attr('action'),
                                data: form.serialize()
                            }, function (data) {
                                orgInfos = jQuery.parseJSON(data);
                                layer.msg("Les informations ont bien été enregistrées");
                                refreshOrganismes(orgInfos);
                            });
                            $(this).parents(".modal").modal('hide');
                            $(this).parents(".modal").empty();
                            //                            refreshContactInfos(contactId);
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    }
                }
            });
        }
    }).appendTo($('#CourrierOrganismeId').parent());

<?php
//$addContactImg = $this->Html->image('/img/contact_add_16.png', array('id' => 'addContact', 'name' => 'addContact', 'title' => __d('addressbook', 'Contact.add')));
$addContactImg = '<i class="fa fa-plus-circle table" id=addContact name=addContact title="Ajouter un contact"></i>';
?>
    var addContactImg = $('<?php echo $addContactImg; ?>').css({height: '16px', width: '16px', color: '#428bca', float: 'right', margin: '-42px -30px auto auto', cursor: 'pointer'}).click(function () {
        $(".modal").empty();
        orgId = $('#CourrierOrganismeId').val();
        if (orgId == '') {
            var title = "<?php echo __d('contact', 'Contact.add') ?>";
            var text = "<?php echo __d('contact', 'Contact.add.undefined') ?>";
            swal({
                title: 'Oops...',
                text: title + "<br>" + text,
                type: 'warning',
                timer: 1500
            });
        } else {
            gui.formMessage({
                url: "/courriers/add_contact/" + orgId,
                loader: true,
                loaderMessage: gui.loaderMessage,
                updateElement: $('#addContact').parents('fieldset'),
                width: 550,
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {
                        var form = $(this).parents('.modal').find('form');
                        if (form_validate(form)) {
                            gui.request({
                                url: form.attr('action'),
                                data: form.serialize()
                            }, function (data) {
                                contactInfos = jQuery.parseJSON(data);
                                layer.msg("Les informations ont bien été enregistrées");
                                refreshContact(contactInfos);
                            });
                            $(this).parents(".modal").modal('hide');
                            $(this).parents(".modal").empty();
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    }
                }

            });
        }
    }).appendTo($('#CourrierContactId').parent());

    // Modification contact
<?php
//$editContactImg = $this->Html->image('/img/tool.png', array('id' => 'editContact', 'name' => 'editContact', 'title' => __d('contact', 'Contact.edit')));
$editContactImg = '<i class="fa fa-pencil table" id=editContact name=editContact title="Modifier le contact"></i>';
?>
    var editContactImg = $('<?php echo $editContactImg; ?>').css({height: '16px', color: '#428bca', width: '16px', float: 'right', margin: '-42px -50px auto auto', cursor: 'pointer'}).click(function () {
        orgId = $('#CourrierOrganismeId').val();
        contactId = $('#CourrierContactId').val();
        if (contactId == "<?php echo $sansContact; ?>") {
            var title = "<?php echo __d('contact', 'Contact.edit') ?>";
            var text = "<?php echo __d('contact', 'Contact.edit.forbidden') ?>";
            swal({
                title: 'Oops...',
                text: title + "<br>" + text,
                type: 'warning',
                timer: 1500
            });

        }
        /*
         if (contactId == '') {
         var title = "<?php echo __d('contact', 'Contact.edit') ?>";
         var text = "<?php echo __d('contact', 'Contact.edit.undefined') ?>";
         swal(
         'Oops...',
         title + "<br>" + text,
         'warning'
         );
         }*/
        else {
            url = "/courriers/edit_contact/" + contactId;
            $(".modal").empty();
            gui.formMessage({
                url: url,
                loader: true,
                loaderMessage: gui.loaderMessage,
                updateElement: $('#editContact').parents('fieldset'),
                width: 600,
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {
                        var form = $('#CourrierEditContactForm');
                        if (form_validate(form)) {
                            gui.request({
                                url: form.attr('action'),
                                data: form.serialize()
                            }, function (data) {
                                contactInfos = jQuery.parseJSON(data);
                                layer.msg("Les informations ont bien été enregistrées");
                                refreshContact(contactInfos);
                            });
                            $(this).parents(".modal").modal('hide');
                            $(this).parents(".modal").empty();
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    }
                }
            });
        }
    }).appendTo($('#CourrierContactId').parent());
    showContactinfo();
    showOrganismeinfo();
    $("input[name='data[Courrier][datereception]']").bind('change', function () {
        gui.request({
            url: "/courriers/ajaxformvalid/datereception",
            data: $('#CourrierCreateInfosForm').serialize()
        }, function (data) {
            processJsonFormCheck(data);
        });
    });
    $("input[name='data[Courrier][date]']").bind('change', function () {
        gui.request({
            url: "/courriers/ajaxformvalid/date",
            data: $('#CourrierCreateInfosForm').serialize()
        }, function (data) {
            processJsonFormCheck(data);
        });
    });</script>

<script type="text/javascript">
<?php 
//    $toolTipImg = $this->Html->image('/img/help-contents.png', array('id' => 'tooltipImage','name' => 'tooltipImage' , 'title' => __d('soustype', 'Soustype.information')) );
    $toolTipImg = '<i class="fa fa-info table" id=tooltipImage name=tooltipImage title="Informations"></i>';
?>

    $('<?php echo $toolTipImg; ?>').css({height: '20px', width: '20px', color:'#428bca'}).appendTo($('#s2id_CourrierSoustypeId').parent()).css("cursor", "pointer").css("margin", "-42px -29px auto auto").css("float", "right");
    $('#CourrierSoustypeId').change(function () {
        var dataString = 'id=' + $('#CourrierSoustypeId').val();
        if ($('#CourrierSoustypeId').val() != null) {
            $.ajax({
                type: 'post',
                url: '/Soustypes/getInformation/' + $('#CourrierSoustypeId').val(),
                data: dataString,
                success: function (data) {
                    if (data != "") {
                        $('#tooltipImage').popover({content: data, container: $('#tooltipImage').parent()});
                    } else {
                        $('#tooltipImage').popover({content: "Aucune information", container: $('#tooltipImage').parent()});
                    }
                }
            });
        }
    });
    $('#s2id_PliconsultatifHeureHour').css({
        width: '48%',
        float: 'left'
    });
    $('#s2id_PliconsultatifHeureMin').css({
        width: '48%',
        float: 'right'
    });
    $('#CourrierDelaiNb').css({
        width: '50%'
    });
    function mousePosition(ev) {
        ev = ev || window.event;
        if (ev.pageX || ev.pageY) {
            return {x: ev.pageX, y: ev.pageY};
        }
        return {
            x: ev.clientX + document.body.scrollLeft - document.body.clientLeft,
            y: ev.clientY + document.body.scrollTop - document.body.clientTop
        };
    }




    var checkExists = function () {
        $('.exists').remove();
        $.ajax({
            type: 'post',
            dataType: 'json',
            url: '/Ordresservices/getExistance',
            data: $('#CourrierSetInfosForm').serialize(),
            success: function (data) {
                if (data.length > 0) {
                    var exists = $('<div></div>').html('<?php echo __d('ordreservice', 'Ordreservice.ExistsListTitle'); ?>').addClass('exists').addClass('ui-state-highlight');
                    $('#OrdreserviceNumero').parent().after(exists);
                }
            }
        });
    }

    function updateContextRight(newCourrierId) {
        var url = window.location.href;
        var urlCouper = url.split('/');
        var desktopId = urlCouper[urlCouper.length - 1];
        gui.request({
            url: '/courriers/updateContext/' + newCourrierId + '/' + desktopId
        }, function (data) {
            $('#flux_context').html(data);
        });

    }
</script>

<?php
}
?>
