<?php

/**
 *
 * Courriers/set_infos.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
echo $this->Html->script('formValidate.js', array('inline' => true));
echo $this->Html->script('contactinfo.js', array('inline' => true));
echo $this->Html->script('setInfos.js', array('inline' => true));
?>

<?php 
if (!empty($newCourrierId)) {
    echo $newCourrierId;
} else {
    $direction = array(
        0 => array(
//            'img' => $this->Html->image('/img/folder_outbox.png'),
            'img' => '<i class="fa fa-sign-out" style="color:#e51809;" aria-hidden="true"></i>',
            'txt' => __d('courrier', 'Courrier.courrier_sortant'),
            'contact' => 'dest'
        ),
        1 => array(
//            'img' => $this->Html->image('/img/folder_inbox.png'),
            'img' => '<i class="fa fa-sign-in" style="color:#2ec07e;" aria-hidden="true"></i>',
            'txt' => __d('courrier', 'Courrier.courrier_entrant'),
            'contact' => 'exp'
        ),
        2 => array(
            'img' => $this->Html->image('/img/flux_interne.png'),
            'txt' => __d('courrier', 'Courrier.courrier_interne'),
            'contact' => 'exp'
        )
    );

//    $tabDelaiUnite = array('jour', 'semaine', 'mois');
    $tabDelaiUnite = array(
        0 => 'jour',
        1 => 'semaine',
        2 => 'mois'
    );

    $formOptions = array(
        'type' => 'file',
        'url' => array(
            'controller' => 'courriers',
            'action' => 'setQualification',
            $this->data['Courrier']['id']
        )
    );
?>
<script type="text/javascript">
    var contactLists = <?php echo json_encode($contactOptions); ?>;
</script>

<?php
    $url = array('controller' => 'courriers', 'action' => 'setInfos');
    if (isset($this->data['Courrier']['id'])) {
        $url[] = $this->data['Courrier']['id'];
    }
    $formCourrier = array(
        'name' => 'Courrier',
        'label_w' => 'col-sm-3',
        'input_w' => 'col-sm-5',
        'form_url' => $url,
        'input' => array(
            'Courrier.id' => array(
                'inputType' => 'hidden',
                'items'=>array(
                    'type'=>'hidden'
                )
            )
        )
    );
    echo $this->Formulaire->createForm($formCourrier);
    
    $priorites = array(
        0 => __d('courrier', 'Courrier.priorite_basse'),
        1 => __d('courrier', 'Courrier.priorite_moyenne'),
        2 => __d('courrier', 'Courrier.priorite_haute')
    );
         
    $formCourrierFlux = array(
        'name' => 'Courrier',
        'label_w' => 'col-sm-4',
        'input_w' => 'col-sm-8',
        'form_url' => $url,
        'input' => array(
            'Courrier.id' => array(
                'inputType' => 'hidden',
                'items'=>array(
                    'type'=>'hidden'
                )
            )
        )
    );
    $formCourrierFlux['input']['Courrier.name'] =array(
        'labelText' =>__d('courrier', 'Courrier.name'),
        'inputType' => 'text',
        'items'=>array(
            'required'=>true,
            'type'=>'text'
        )
    );
    $formCourrierFlux['input']['Courrier.origineflux_id'] =array(
        'labelText' =>__d('courrier', 'Courrier.origineflux_id'),
        'inputType' => 'select',
        'items'=>array(
            'type' => 'select', 
            'options' => $origineflux, 
            'empty' => true
        )
    );
    $formCourrierFlux['input']['Courrier.direction'] =array(
        'labelText' =>__d('courrier', 'Courrier.direction'),
        'inputType' => 'hidden',
        'items'=>array(
            'type'=>'hidden'
        )
    );
    $formCourrierFlux['input']['Courrier.objet'] =array(
        'labelText' =>__d('courrier', 'Courrier.objet'),
        'inputType' => 'textarea',
        'items'=>array(
            'type'=>'textarea'
        )
    );
    $formCourrierFlux['input']['Courrier.priorite'] =array(
        'labelText' =>__d('courrier', 'Courrier.priorite'),
        'inputType' => 'select',
        'items'=>array(
            'type' => 'select', 
            'options' => $priorites, 
            'default' => 0
        )
    );
    if( !Configure::read('Conf.SAERP') ) {
        $formCourrierFlux['input']['Courrier.affairesuiviepar_id'] = array(
            'labelText' => __d('courrier', 'Courrier.affairesuiviepar_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                'options' => $allDesktops, 
                'empty' => true
            )
        );
    }
    
 ?>
<!--<div class="row">-->

    <?php if( $isInCircuit && !empty($descriptionEtape) ):?>
<div class="alert alert-info"><b>Description de l'étape de traitement en cours : </b><?php echo $descriptionEtape; ?></div>
    <?php  endif;?>
<div class="zone" >
    <legend id="flux" ><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Courrier.fluxFieldset'); ?></legend>
    <div id="fluxdata" class="panel-body form-horizontal">
    <?php echo $this->Formulaire->createForm($formCourrierFlux); ?>
    </div>
</div>

<script type="text/javascript">
    $('#flux').click(function () {
        $('#fluxdata').toggle();
    });    
</script>
<?php
 
    $listeUnite = Set::enum( $this->data['Soustype']['delai_unite'], $tabDelaiUnite );
    $soustypeDelaiNb = (isset($this->data['Courrier']['delai_nb'])) ? $this->data['Courrier']['delai_nb'] : $this->data['Soustype']['delai_nb'];
    $soustypeDelaiUnite = (isset($this->data['Courrier']['delai_unite'])) ? $this->data['Courrier']['delai_unite'] : $this->data['Soustype']['delai_unite'];
    
    $soustypeEntrantContent = (isset($this->data['Soustype']['entrant']) ? $direction[$this->data['Soustype']['entrant']]['img'] . " " . $direction[$this->data['Soustype']['entrant']]['txt'] : '');
    $spanSoustypeEntrantContent = $this->Html->tag('span', $soustypeEntrantContent, array('class' => 'form-control fakeDisabledInputText','readonly'=> true));
    
    $formCourrierQualification = array(
            'name' => 'Courrier',
            'label_w' => 'col-sm-4',
            'input_w' => 'col-sm-8',
            'form_url' => $url,
            'input' => array(
                'Courrier.id' => array(
                    'inputType' => 'hidden',
                    'items'=>array(
                        'type'=>'hidden'
                    )
                )
            )
        );
   
    if( Configure::read('Conf.SAERP') ) {
        $formCourrierQualification['input']['Courrier.typedocument'] =array(
            'labelText' =>__d('courrier', 'Courrier.typedocument'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => $typesdocument,
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Courrier.marche_id'] =array(
            'labelText' =>__d('courrier', 'Courrier.marche_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => !empty($marches)? $marches : array(), 
                'empty' => true
            )
        );
        $formCourrierQualification['input']['Courrier.consultation_id'] =array(
            'labelText' =>__d('courrier', 'Courrier.consultation_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select', 
                "options" => $consultations,
                'empty' => true
            )
        );
        if( !empty( $this->request->data['Ordreservice']['id']) ) {
            $formCourrierQualification['input']['Ordreservice.id'] =array(
                'inputType' => 'hidden',
                'items'=>array(
                    'type' => 'hidden',
                    'value' => $this->request->data['Ordreservice']['id']
                )
            );
        }
        $formCourrierQualification['input']['Ordreservice.numero'] =array(
            'labelText' =>__d('ordreservice', 'Ordreservice.numero'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text',
                 'value' => $valueNumberOs
            )
        );
        $formCourrierQualification['input']['Ordreservice.objet'] =array(
            'labelText' =>__d('ordreservice', 'Ordreservice.objet'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Ordreservice.montant'] =array(
            'labelText' =>__d('ordreservice', 'Ordreservice.montant'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Ordreservice.marche_id'] =array(
            'inputType' => 'hidden',
            'items'=>array(
                'type' => 'hidden'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.origineflux_id'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.origineflux_id'),
            'inputType' => 'select',
            'items'=>array(
                'type' => 'select',
                'empty' => true,
                'options' => $origineflux
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.numero'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.numero'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.lot'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.lot'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.objet'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.objet'),
            'inputType' => 'text',
            'items'=>array(
                'type' => 'text'
            )
        );
        
        $formCourrierQualification['input']['Pliconsultatif.date'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.date'),
            'inputType' => 'text',
            'dateInput' =>true,
            'items'=>array(
                'type' => 'text',
                'class' => 'datepickerPli',
                'readonly' => true,
                'data-format'=>'dd/MM/yyyy'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.marche_id'] =array(
            'inputType' => 'hidden',
            'items'=>array(
                'type' => 'hidden'
            )
        );
        $formCourrierQualification['input']['Pliconsultatif.heure'] =array(
            'labelText' =>__d('pliconsultatif', 'Pliconsultatif.heure'),
            'inputType' => 'time',
            'items'=>array(
                'type' => 'time',
                'timeFormat' => '24',
                'interval' => 05,
                'empty' => true
            )
        );  
    }
    $formCourrierQualification['input']['Types.Type'] = array(
        'labelText' =>__d('type', 'Type'),
        'inputType' => 'select',
        'items'=>array(
            'type'=>'select',
//            "options" =>array(), 
            "options" =>$typeOptions, 
            'disabled' => $isInCircuit ? 'disabled' : '', 
            'empty' => true,
            'value'=>$this->request->data['Type']['id']
        )
    );
    
    $formCourrierQualification['input']['Courrier.soustype_id'] = array(
        'labelText' =>__d('soustype', 'Soustype'),
        'inputType' => 'select',
        'items'=>array(
            'type' => 'select', 
            "options" =>array(),
            'disabled' => $isInCircuit ? 'disabled' : '', 
            'empty' => true,
            'value'=>$this->request->data['Soustype']['id']
        )
    );
    $formCourrierQualification['input']['Courrier.reference'] = array(
        'labelText' =>__d('courrier', 'Courrier.reference'),
        'inputType' => 'text',
        'items'=>array(
            'type'=>'text',
            'readonly' => true,
            'class' => 'fakeDisabledInputText',
            'value' =>(isset($this->data['Courrier']['reference']) ? $this->data['Courrier']['reference'] : '')
        )
    );
    $formCourrierQualification['input']['Courrier.entrant'] = array(
        'labelText' =>__d('courrier', 'Courrier.entrant/sortant'),
        'inputType' => 'text',
        'items'=>array(
            'type' => 'text',
            'readonly' => true
        )
    ); 
    $formCourrierQualification['input']['Courrier.delai_nb'] = array(
        'labelText' =>'Délai de traitement',
        'inputType' => 'text',
        'items'=>array(
            'type' => 'text', 
            'empty' => true,
            'class' =>'fakeDisabledInputText',
            'value' => $soustypeDelaiNb
        )
    );
    $formCourrierQualification['input']['Courrier.delai_unite'] = array(
        'labelText' =>false,
        'inputType' => 'select',
        'items'=>array(
            'type' => 'select', 
            'options' => $tabDelaiUnite, 
            'value' => $soustypeDelaiUnite,
            'selected' => $soustypeDelaiUnite,
            'empty' => true,
            'class' => 'unitecreate'
        )
    );
?>
<div class="zone" >
    <legend id="qualif"><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Qualification'); ?></legend>
    <div  id="qualifdata" class="panel-body  form-horizontal" >
    <?php echo $this->Formulaire->createForm($formCourrierQualification); ?>
        <div class='col-sm-11 defautDelaiInfo'><div class='col-sm-6'></div>(par défaut <?php echo $this->data['Soustype']['delai_nb'].' '.$listeUnite;?>s)</div>
    </div>
</div>

<script type="text/javascript">
    $('#qualif').click(function () {
        $('#qualifdata').toggle();
    });    
</script>

<div class="zone">
    <legend id="acteur"><i  class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Acteurs'); ?></legend>
    <?php 
    if( $isAdmin && !$isInCircuit ) {
        $formCourrierAdmin = array(
            'name' => 'Courrier',
            'label_w' => 'col-sm-6',
            'input_w' => 'col-sm-5',
            'input' => array(
                'Bancontenu.desktop_id' => array(
                    'inputType' => 'select',
                    'labelText' => 'Positionner le flux vers le profil suivant :',
                    'items'=>array(
                        'type'=>'select',
                        'options' => $desktopsAdmin,
                        'empty' => true
                    )
                )
            )
        ); 
        echo $this->Formulaire->createForm($formCourrierAdmin);
    }
    ?>
    <div id="acteurdata" class="panel-body form-horizontal fieldsetView">
        <table  id="acteursTable" data-toggle="table"  data-locale = "fr-CA" data-show-columns="true"> 
            <thead>
            <th><i class="fa fa-desktop" aria-hidden="true" title="Nom du bureau ayant traité le flux"></i></th>
            <th><i class="fa fa-user" aria-hidden="true" title="Nom de l'agent ayant traité le flux"></i></th>
            <th><i class="fa fa-id-card-o" aria-hidden="true" title="Rôle de l'agent ayant traité le flux"></i></th>
            <th><i class="fa fa-calendar-check-o" aria-hidden="true" title="Date d'arrivée chez l'agent"></i></th>
            <th><i class="fa fa-calendar-check-o" aria-hidden="true" title="Date de dernière modification"></i></th>
            <th><i class="fa fa-calendar-check-o" aria-hidden="true" title="Date de validation"></i></th>
            <th><i class="fa fa-files-o" aria-hidden="true"  title="Pour copie ?"></i></th>
            </thead>
            <tbody>
            <?php foreach( $bannettes as $key => $bannette ):?>
                <?php
                // Affichage de l'icône pour copie ou non
                    $bannetteName = $bannette['Bannette']['name'];
                    // Utilisateur ayant réalisé l'action
                    $user = @$bannette['Desktop']['User'][0]['nom'].' '.@$bannette['Desktop']['User'][0]['prenom'];
                    if( $user == ' ' ) {
                        $user = @$bannette['Desktop']['SecondaryUser'][0]['nom'].' '.@$bannette['Desktop']['SecondaryUser'][0]['prenom'];
                    }
                ?>
                <tr>
                    <td class="tdDate"><?php echo $bannette['Desktop']['name'];?></td>
                    <td class="tdDate"><?php echo $user;?></td>
                    <td class="tdDate"><?php echo $bannette['Desktop']['Group']['name'];?></td>
                    <td class="tdDate"><?php echo strftime( '%d/%m/%Y %T', strtotime( $bannette['Bancontenu']['created'] ) );?></td>
                    <td class="tdDate"><?php echo !empty($bannette['Bancontenu']['modified']) ? strftime( '%d/%m/%Y %T', strtotime( $bannette['Bancontenu']['modified'] ) ) : '';?></td>
                    <td class="tdDate"><?php echo !empty($bannette['Bancontenu']['validated']) ? strftime( '%d/%m/%Y %T', strtotime( $bannette['Bancontenu']['validated'] ) ) : '';?></td>
                    <td class="tdState"><?php echo ($bannetteName == 'copy' ) ? $this->Html->image('/img/valid_16.png', array('alt' => 'Pour copie', 'title' => 'Flux envoyé pour copie' ) ) : null;?></td>
                </tr>
                        <?php endforeach;?>
            </tbody>
        </table>
    </div>
</div>

<script type="text/javascript">
    $('#acteur').click(function () {
        $('#acteurdata').toggle();
    });    
</script>


<?php 
    $formCourrierContact = array(
        'name' => 'Courrier',
        'label_w' => 'col-sm-6',
        'input_w' => 'col-sm-5',
        'input' => array(
            'Courrier.organisme_id' => array(
                'inputType' => 'select',
                'labelText' =>__d('courrier', 'Courrier.contact'),
                'items'=>array(
                    'type'=>'select',
//                    'options' => array()
                    'options' =>$organismOptions
                )
            ),
            'Courrier.contact_id' => array(
                'inputType' => 'select',
                'labelText' =>__d('courrier', 'Courrier.contact_id'),
                'items'=>array(
                    'type'=>'select',
                    'options' => array()
                )
            )
        )
    );
?>
<div class="zone" >
    <legend id="contact"><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Courrier.contactFieldset'); ?></legend>
    <div id="contactdata" class="panel-body  form-horizontal" >
    <?php echo $this->Formulaire->createForm($formCourrierContact); ?>
    </div>
</div>

<script type="text/javascript">
    $('#contact').click(function () {
        $('#contactdata').toggle();
    });    
</script>
<?php   
 $formCourrierDate = array(
            'name' => 'Courrier',
            'label_w' => 'col-sm-6',
            'input_w' => 'col-sm-5',
            'input' => array(
                'Courrier.datereception' => array(
                    'inputType' => 'text',
                    'labelText' =>__d('courrier', 'Courrier.datereception'),
                    'dateInput' =>true,
                    'items'=>array(
                        'type'=>'text',
                        'readonly' => true,
                        'data-format'=>'dd/MM/yyyy'
                    )
                ),
                'Courrier.date' => array(
                    'inputType' => 'text',
                    'labelText' =>__d('courrier', 'Courrier.date'),
                    'dateInput' =>true,
                    'items'=>array(
                        'type'=>'text',
                        'readonly' => true,
                        'data-format'=>'dd/MM/yyyy'
                    )
                )
            )
        );
    
?>
<div class="zone">
    <legend id="dates"><i  class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Courrier.dateFieldset'); ?></legend>
    <div id="datesdata" class="panel-body  form-horizontal" >
                <?php echo $this->Formulaire->createForm($formCourrierDate); ?>
    </div>
</div>

<script type="text/javascript">
    $('#dates').click(function () {
        $('#datesdata').toggle();
    });    
</script>
<?php 
echo $this->Form->end();
?>
<div class="alert alert-info col-sm-11" id="autoSaveInfo">
</div>

<script type="text/javascript">
    $("document").ready(function () {
//        <div class="select2-container form-control select2-allowclear" id="s2id_PliconsultatifHeureMin" title=""><a href="javascript:void(0)" class="select2-choice" tabindex="-1">   <span class="select2-chosen" id="select2-chosen-10">30</span><abbr class="select2-search-choice-close"></abbr>   <span class="select2-arrow" role="presentation"><b role="presentation"></b></span></a><label for="s2id_autogen10" class="select2-offscreen"></label><input class="select2-focusser select2-offscreen" aria-haspopup="true" role="button" aria-labelledby="select2-chosen-10" id="s2id_autogen10" type="text"><div class="select2-drop select2-display-none select2-with-searchbox">   <div class="select2-search">       <label for="s2id_autogen10_search" class="select2-offscreen"></label>       <input autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" class="select2-input" role="combobox" aria-expanded="true" aria-autocomplete="list" aria-owns="select2-results-10" id="s2id_autogen10_search" placeholder="" type="text">   </div>   <ul class="select2-results" role="listbox" id="select2-results-10">   </ul></div></div>
        <?php if(!empty( $organismeid ) ) :?>
        $("#CourrierOrganismeId").val("<?php echo $organismeid;?>").change();
        <?php else:?>
        // par défaut, on attribue la valeur de l'organisme sans organisme
        $("#CourrierOrganismeId").val("<?php echo $sansOrganisme;?>").change();
        var organisme_id = $("#CourrierOrganismeId").val();
        if (organisme_id != '') {
//            refreshOrganismeInfos(organisme_id);
        }
        <?php endif;?>
        chargementOptionsContact(<?php echo json_encode($contactOptions); ?>);
        <?php if(!empty( $contactid ) ) :?>
        $("#CourrierContactId").val("<?php echo $contactid;?>").change();
//        if ($('#CourrierContactId').val() != '' && $('#CourrierContactId').val() != null) {
//            refreshContactInfos($('#CourrierContactId').val());
//        }
        <?php else:?>
        // par défaut, on attribue la valeur de l'organisme sans organisme
        $("#CourrierContactId").val("<?php echo $sansContact;?>").change();
//        if ($('#CourrierContactId').val() != '' && $('#CourrierContactId').val() != null) {
//            refreshContactInfos($('#CourrierContactId').val());
//        }
        <?php endif;?>
            
    });




    //contruction du tableau de types / soustypes
    $('#TypesType').change(function () {
        var type_id = $(this).val();
        var soustypeLists = <?php echo json_encode($soustypeOptions); ?>;
        $('#CourrierSoustypeId option').remove();

        // On est obligés de passer par un array car on ne peut trier les clés d'un objet
        var options = [];
        for (var value in soustypeLists[type_id]) {
            options.push([value, soustypeLists[type_id][value]]);
        }
        options.sort(function(a, b) {
            if(a[1] < b[1]) return -1;
            else if(a[1] > b[1]) return 1;
            return 0;
        });

        $.each(options, function (index, value) {
            $('#CourrierSoustypeId').append($("<option value='" + value[0] + "'>" + value[1] + "</option>"));
        });
    });
        <?php if(!empty( $typeId ) ) :?>
    $("#TypesType").val("<?php echo $typeId;?>").change();
        <?php endif;?>
        <?php if(!empty( $soustypeid ) ) :?>
    $("#CourrierSoustypeId").val("<?php echo $soustypeid;?>").change();
        <?php endif;?>


    var fieldsetContactLegendExp = "<?php echo __d('courrier', 'Courrier.contactFieldset.exp'); ?>";
    var fieldsetContactLabelCourrierContactNameExp = "<?php echo __d('courrier', 'Courrier.contact.exp'); ?>";
    var fieldsetContactLabelCourrierContactExp = "<?php echo __d('courrier', 'Courrier.contactinfo.exp'); ?>";

    var fieldsetContactLegendDest = "<?php echo __d('courrier', 'Courrier.contactFieldset.dest'); ?>";
    var fieldsetContactLabelCourrierContactNameDest = "<?php echo __d('courrier', 'Courrier.contact.dest'); ?>";
    var fieldsetContactLabelCourrierContactDest = "<?php echo __d('courrier', 'Courrier.contactinfo.dest'); ?>";



    //definition de l action sur stype
    $("#CourrierSoustypeId").change(function () {
        var stype_id = $('option:selected', this).attr('value');
//        $('.msgChange').remove();
        var reloadImgString = '<?php echo $this->Html->image('/img/reload.png'); ?>';
        var reloadImgFullString = '<?php echo $this->Html->image('/img/reload.png', array('alt' => __d('courrier', 'Courrier.messagechange.short'), 'title' => __d('courrier', 'Courrier.messagechange'))); ?>';
        $('.fakeDisabledInputText').after($('<span></span>').addClass('msgChange').html(reloadImgString + ' ' + "<?php echo __d('courrier', 'Courrier.messagechange'); ?>"));
        $('#delai').after($('<div></div>').addClass('msgChange').html(reloadImgString + ' ' + "<?php echo __d('courrier', 'Courrier.messagechange'); ?>"));
        $('.context_accordion .ui-accordion-header').each(function () {
            if ($('a', this).length > 0) {
                $(this).append($('<span></span>').addClass('msgChange').html(reloadImgFullString));
            }
        });
        if ($('.msgChange').is(':visible')) {
            $('.unitecreate').css('top', '-78px');
        }
    });

<?php if( Configure::read('Conf.SAERP')) :?>
    $(document).ready(function () {        
        $("<div id='ordreservice'>").insertBefore($('#OrdreserviceNumero').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceNumero').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceObjet').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceMontant').parents('.form-group'));
        $("#ordreservice").append($('#OrdreserviceMarcheId'));
        $("<div id='pliconsultatif'>").insertBefore($('#PliconsultatifOriginefluxId').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifOriginefluxId').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifNumero').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifLot').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifObjet').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifDate').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifHeureHour').parents('.form-group'));
        $("#pliconsultatif").append($('#PliconsultatifMarcheId'));
        $("<div id='marche'>").insertBefore($('#CourrierMarcheId').parents('.form-group'));
        $("#marche").append($('#CourrierMarcheId').parents('.form-group'));
        $("<div id='consult'>").insertBefore($('#CourrierConsultationId').parents('.form-group'));
        $("#consult").append($('#CourrierConsultationId').parents('.form-group'));
    });
    $('#PliconsultatifOriginefluxId').select2({allowClear: true, placeholder: "Sélectionner un mode de réception"});
    $('#PliconsultatifHeureHour').select2({allowClear: true});
    $('#PliconsultatifHeureMin').select2({allowClear: true});
    $('#s2id_PliconsultatifHeureHour').css({
        width: '48%',
        float: 'left'
    });

    $('#s2id_PliconsultatifHeureMin').css({
        width: '48%',
        float: 'right'
    });
    $("#CourrierConsultationId").select2({allowClear: true, placeholder: "Sélectionner une consultation"});
    $("#CourrierMarcheId").select2({allowClear: true, placeholder: "Sélectionner un marché"});
    $("#CourrierTypedocument").select2({allowClear: true, placeholder: "Sélectionner un type de document"});
    $('#ordreservice').hide();
    $('#pliconusltatif').hide();
    $('#consult').hide();
    $('#marche').hide();
    // Lors de lé selection du marché, on remplit le champ Type
    $('#CourrierMarcheId').change(function () {
        gui.request({
            url: "/courriers/ajaxformtype/marcheid",
            data: $('#CourrierSetInfosForm').serialize()
        }, function (data) {
            processJsonFormCheck(data);
            $("#TypesType option").each(function () {
                if ($(this).attr('value') == $.trim(data)) {
                    $(this).attr('selected', 'selected').change();
                }
            });
        });
    });
    // Si le marché est sélectionné, on affiche les infos de l'OS et on calcule le numéro de l'OS
    // on sélectionne le type
    $('#CourrierTypedocument').change(function () {
        var marcheid = $('#CourrierMarcheId').val();
        var consultationId = $('#CourrierConsultationId').val();
        if ($('#CourrierTypedocument').val() == 'OS') {
            // SI c'es tun OS, on affiche les infos
            $('#ordreservice').show();
            $('#consult').hide();
            $('#marche').show();
            $('#pliconsultatif').hide();
            // SI c'es tun OS, on calcule le numéro
            gui.request({
                url: "/ordresservices/ajaxformdata/typedocument/" + marcheid,
                data: $('#CourrierSetInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#OrdreserviceNumero').val($.trim(data)).change();
            });
        }
        else if ($('#CourrierTypedocument').val() == 'PLI') {
            $('#ordreservice').hide();
            $('#consult').show();
            $('#marche').hide();
            $('#pliconsultatif').show();
            gui.request({
                url: "/plisconsultatifs/ajaxformdata/typedocument/" + consultationId,
                data: $('#CourrierSetInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#PliconsultatifNumero').val($.trim(data)).change();
            });
        }
        else if ($('#CourrierTypedocument').val() == 'LN') {
            $('#ordreservice').hide();
            $('#consult').hide();
            $('#marche').show();
            $('#pliconsultatif').hide();
        }
        else if ($('#CourrierTypedocument').val() == 'LC') {
            $('#ordreservice').hide();
            $('#consult').hide();
            $('#marche').hide();
            $('#pliconsultatif').hide();
        }
        else {
            // sinon on masque les infos
            $('#ordreservice').hide();
            $('#pliconsultatif').hide();
            $('#consult').hide();
            $('#marche').hide();
        }
    });
    if ($('#CourrierTypedocument').val() == 'OS') {
        $('#ordreservice').show();
        $('#pliconsultatif').hide();
        $('#consult').hide();
        $('#marche').show();
    }
    else if ($('#CourrierTypedocument').val() == 'PLI') {
        $('#ordreservice').hide();
        $('#pliconsultatif').show();
        $('#consult').show();
        $('#marche').hide();
    }
    else if ($('#CourrierTypedocument').val() == 'LN') {
        $('#ordreservice').hide();
        $('#consult').hide();
        $('#marche').show();
        $('#pliconsultatif').hide();
    }
    else if ($('#CourrierTypedocument').val() == 'LC') {
        $('#ordreservice').hide();
        $('#consult').hide();
        $('#marche').hide();
        $('#pliconsultatif').hide();
    }
    else {
        $('#ordreservice').hide();
        $('#pliconsultatif').hide();
        $('#consult').hide();
        $('#marche').hide();
    }

    // Si on modifie le marché
    $('#CourrierMarcheId').change(function () {
        // Si c'st un OS
        if ($('#CourrierTypedocument').val() == 'OS') {
            var marcheid = $('#CourrierMarcheId').val();
            // on recalcule le numéro de l'OS
            gui.request({
                url: "/ordresservices/ajaxformdata/typedocument/" + marcheid,
                data: $('#CourrierSetInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#OrdreserviceNumero').val($.trim(data)).change();
            });
        }
    });
    $('#CourrierConsultationId').change(function () {
        // sinon Si c'st un pli
        if ($('#CourrierTypedocument').val() == 'PLI') {
            var consultationId = $('#CourrierConsultationId').val();
            // on recalcule le numéro du pli
            gui.request({
                url: "/plisconsultatifs/ajaxformdata/typedocument/" + consultationId,
                data: $('#CourrierSetInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
                $('#PliconsultatifNumero').val($.trim(data)).change();
            });
        }

    });
<?php endif;?>

<?php if( $isAdmin && !$isInCircuit):?>
    $('#BancontenuDesktopId').select2({allowClear: true, placeholder: "Sélectionner un nouveau profil"});
<?php endif;?>
    //contruction du tableau de types / soustypes
    $('#CourrierOrganismeId').change(function () {
        showOrganismeinfo();
        showContactinfo();
        var organisme_id = $(this).val();
        if (organisme_id != '') {
            refreshOrganismeInfos(organisme_id);
        }
        chargementOptionsContact(<?php echo json_encode($contactOptions); ?>);
    });
// Actions pour la partie Organisme
    <?php
//        $addOrganismeImg = $this->Html->image('/img/contact_add_16.png', array('id' => 'addOrganisme', 'name' => 'addOrganisme', 'title' => __d('organisme', 'Organisme.add')));
        $addOrganismeImg = '<i class="fa fa-plus-circle table" id=addOrganisme name=addOrganisme title="Ajouter un organisme"></i>';
    ?>
    var addOrganismeImg = $('<?php echo $addOrganismeImg; ?>').css({height: '16px', width: '16px', color: '#428bca', float: 'right', margin: '-42px -30px auto auto', cursor: 'pointer'}).click(function () {
        gui.formMessage({
            url: "/courriers/add_organisme",
            loader: true,
            loaderMessage: gui.loaderMessage,
            updateElement: $('#addOrganisme').parents('fieldset'),
            width: 700,
            top: "-10px",
            buttons: {
                "<?php echo __d('default', 'Button.submit'); ?>": function () {
                    var form = $('#CourrierAddOrganismeForm');
                    if (form_validate(form)) {
                        gui.request({
                            url: form.attr('action'),
                            data: form.serialize()
                        }, function (data) {
                            orgInfos = jQuery.parseJSON(data);
                            layer.msg("Les informations ont bien été enregistrées");
                            refreshOrganismes(orgInfos);
                        });
                        $(this).parents('.modal').modal('hide'); 
                        $(this).parents('.modal').empty();
                    } else {
                        swal({
                            title: "Oops...",
                            text: "Veuillez vérifier votre formulaire!",
                            type: "error",
                            timer: 1500
                        });
                    }
                },
                "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                    $(this).parents('.modal').modal('hide');
                    $(this).parents('.modal').empty();
                }
            }
        });
    }).appendTo($('#CourrierOrganismeId').parent());
    <?php
//    $editOrganismeImg = $this->Html->image('/img/tool.png', array('id' => 'editOrganisme', 'name' => 'editOrganisme', 'title' => __d('organisme', 'Organisme.edit'))); 
    $editOrganismeImg = '<i class="fa fa-pencil table" id=editOrganisme name=editOrganisme title="Modification"></i>';
    ?>
    var editOrganismeImg = $('<?php echo $editOrganismeImg; ?>').css({height: '16px', width: '16px', color: '#428bca', float: 'right', margin: '-42px -50px auto auto', cursor: 'pointer'}).click(function () {
        orgId = $('#CourrierOrganismeId').val();
        contactId = $('#CourrierContactId').val();
        if (orgId == "<?php echo $sansOrganisme; ?>") {
            var title = "<?php echo __d('organisme', 'Organisme.edit') ?>";
            var text = "<?php echo __d('organisme', 'Organisme.edit.forbidden') ?>";
            swal(
                    'Oops...',
                    title + "<br>" + text,
                    'warning'
                    );
        }
        else {
//            if (contactId != '') {
//                url = "/courriers/edit_organisme/" + orgId + '/' + contactId;
//            }
//            else {
            url = "/courriers/edit_organisme/" + orgId;
//            }

            gui.formMessage({
                url: url,
                loader: true,
                loaderMessage: gui.loaderMessage,
                updateElement: $('#editOrganisme').parents('fieldset'),
                width: 700,
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {
                        var form = $('#CourrierEditOrganismeForm');
                        if (form_validate(form)) {
                            gui.request({
                                url: form.attr('action'),
                                data: form.serialize()
                            }, function (data) {
                                orgInfos = jQuery.parseJSON(data);
                                layer.msg("Les informations ont bien été enregistrées");
                                $('.organismeInfoCard').remove();
                                refreshOrganismes(orgInfos);
                            });
                            $(this).parents('.modal').modal('hide');
                            $(this).parents('.modal').empty();
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents('.modal').modal('hide');
                        $(this).parents('.modal').empty();
                    }
                }
            });
        }
    }).appendTo($('#CourrierOrganismeId').parent());
    /*
     $('#CourrierOrganismeId').bind('change', function () {
     showOrganismeinfo();
     if ($('#CourrierOrganismeId').val() != '') {
     refreshOrganismeInfos($('#CourrierOrganismeId').val());
     }
     });
     */
//    $('#CourrierContactId').bind('change', function () {
//        showContactinfo();
//        if ($('#CourrierContactId').val() != '') {
//            refreshContactInfos($('#CourrierContactId').val());
//        }
//    });

<?php
//    $addContactImg = $this->Html->image('/img/contact_add_16.png', array('id' => 'addContact', 'name' => 'addContact', 'title' => __d('addressbook', 'Contact.add')));
    $addContactImg = '<i class="fa fa-plus-circle table" id=addContact name=addContact title="Ajouter un contact"></i>';
    ?>
    var addContactImg = $('<?php echo $addContactImg; ?>').css({height: '16px', width: '16px', color: '#428bca', float: 'right', margin: '-42px -30px auto auto', cursor: 'pointer'}).click(function () {
        orgId = $('#CourrierOrganismeId').val();
        if (orgId == '') {
            var title = "<?php echo __d('contact', 'Contact.add') ?>";
            var text = "<?php echo __d('contact', 'Contact.add.undefined') ?>";
            swal(
                    'Oops...',
                    title + "<br>" + text,
                    'warning'
                    );
        }
        $(".modal").empty();
        gui.formMessage({
            url: "/courriers/add_contact/" + orgId,
            loader: true,
            loaderMessage: gui.loaderMessage,
            updateElement: $('#addContact').parents('fieldset'),
            width: 550,
            buttons: {
                "<?php echo __d('default', 'Button.submit'); ?>": function () {
                    var form = $('#CourrierAddContactForm');
                    if (form_validate(form)) {
                        gui.request({
                            url: form.attr('action'),
                            data: form.serialize()
                        }, function (data) {
                            contactInfos = jQuery.parseJSON(data);
                            layer.msg("Les informations ont bien été enregistrées");
                            refreshContact(contactInfos);
                        });
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    } else {
                        swal({
                            title: "Oops...",
                            text: "Veuillez vérifier votre formulaire!",
                            type: "error",
                            timer: 1500
                        });
                    }
                },
                "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                    $(this).parents(".modal").modal('hide');
                    $(this).parents(".modal").empty();
                }
            }

        });
    }).appendTo($('#CourrierContactId').parent());
// Modification contact
<?php
//    $editContactImg = $this->Html->image('/img/tool.png', array('id' => 'editContact', 'name' => 'editContact', 'title' => __d('contact', 'Contact.edit'))); 
    $editContactImg = '<i class="fa fa-pencil table" id=editContact name=editContact title="Modifier le contact"></i>';
?>
    var editContactImg = $('<?php echo $editContactImg; ?>').css({height: '16px', color: '#428bca', width: '16px', float: 'right', margin: '-42px -50px auto auto', cursor: 'pointer'}).click(function () {
        orgId = $('#CourrierOrganismeId').val();
        contactId = $('#CourrierContactId').val();
        if (contactId == "<?php echo $sansContact; ?>") {
            var title = "<?php echo __d('contact', 'Contact.edit') ?>";
            var text = "<?php echo __d('contact', 'Contact.edit.forbidden') ?>";
            swal(
                    'Oops...',
                    title + "<br>" + text,
                    'warning'
                    );
        }
        $(".modal").empty();
        if (contactId == '' || contactId == null ) {
            var title = "<?php echo __d('contact', 'Contact.edit') ?>";
            var text = "<?php echo __d('contact', 'Contact.edit.undefined') ?>";
            swal(
                    'Oops...',
                    title + "<br>" + text,
                    'warning'
                    );
        } else {
            url = "/courriers/edit_contact/" + contactId;
            gui.formMessage({
                url: url,
                loader: true,
                loaderMessage: gui.loaderMessage,
                updateElement: $('#editContact').parents('fieldset'),
                width: 600,
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {
                        var form = $('#CourrierEditContactForm');
                        if (form_validate(form)) {
                            gui.request({
                                url: form.attr('action'),
                                data: form.serialize()
                            }, function (data) {
                                contactInfos = jQuery.parseJSON(data);
                                layer.msg("Les informations ont bien été enregistrées");
                                $('.organismeInfoCard').remove();
                                refreshOrganismeInfos(contactInfos['contacts']['organisme_id']);
                                $("#CourrierOrganismeId").val(contactInfos['contacts']['organisme_id']).change();
                                refreshContact(contactInfos);
                            });
                            $(this).parents(".modal").modal('hide');
                            $(this).parents(".modal").empty();
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    }
                }
            });
        }
    }).appendTo($('#CourrierContactId').parent());
    var jsContactinfo = $.parseJSON('<?php echo json_encode($contactinfos, JSON_HEX_APOS); ?>');
    if (jsContactinfo != '') {
        $('#CourrierContactId').parent().append(createContactinfo(jsContactinfo['Contactinfo']));
    }

    var jsOrganismeinfo = $.parseJSON('<?php echo json_encode($organismeinfos, JSON_HEX_APOS); ?>');
    if (jsOrganismeinfo != '') {
        $('#CourrierOrganismeId').parent().append(createOrganismeinfo(jsOrganismeinfo['Organisme']));
    }



</script>
<!-- on désactive les champs date d'entrée en collectivité + date de création de flux, une fois inséré dans un circuit -->
<?php if($isInCircuit ) :?>
<script type="text/javascript">
    $('.ui-datepicker-trigger').remove();
    $('#dateAltField').addClass('fakeDisabledInputText');
    $('#datereceptionAltField').addClass('fakeDisabledInputText');</script>
<?php endif;?>

<script type="text/javascript">
    /*debut soustype description*/
    <?php 
//        $toolTipImg = $this->Html->image('/img/help-contents.png', array('id' => 'tooltipImage','name' => 'tooltipImage' , 'title' => __d('soustype', 'Soustype.information')) );
        $toolTipImg = '<i class="fa fa-info table" id=tooltipImage name=tooltipImage title="Informations"></i>';
    ?>
//    $('<?php /*echo $toolTipImg; */?>').appendTo($('#s2id_CourrierSoustypeId').parent()).css("cursor", "pointer").css("margin", "-42px -20px auto auto").css("float", "right");
//    chargeSoustypeInfo(<?php /*echo $this->request->data['Soustype']['id']; */?>);
    $('<?php echo $toolTipImg; ?>').css({height: '20px', width: '20px', color:'#428bca'}).appendTo($('#s2id_CourrierSoustypeId').parent()).css("cursor", "pointer").css("margin", "-42px -29px auto auto").css("float", "right").click(function () {
        chargeSoustypeInfo(<?php echo $this->request->data['Soustype']['id']; ?>);
    });

    /*fin soustype description*/


    //ajouter valeur pour entrant/sortant flux
    $('<div class="form-control col-sm-5 fakeDisabledInputText" ><span><?php echo $soustypeEntrantContent; ?></span></div>').insertAfter($('#CourrierEntrant'));
    $('#CourrierEntrant').hide();
    $('#autoSaveInfo').hide();
    var timeoutId;
    $('#CourrierSetInfosForm input,#CourrierSetInfosForm  select,#CourrierSetInfosForm  textarea').on('input propertychange change', function () {
        clearTimeout(timeoutId);
        timeoutId = setTimeout(function () {
            // Runs 5 second (5000 ms) after the last change    
            saveAuto();
        }, 5000);
    });
    function saveAuto() {
        var fromdisp = <?php echo $fromDisp;?>;
        var hasInitRights = <?php echo $isInit;?>;
        var url = $('#CourrierSetInfosForm').attr('action');
        var soutypeOrigine = '';
        <?php if(!empty($this->request->data['Courrier']['soustype_id'])): ?>
        soutypeOrigine = <?php echo $this->request->data['Courrier']['soustype_id']; ?>;
        <?php endif; ?>

        // Gestion des dates du flux
        $('#CourrierDatereception').change(function () {
            gui.request({
                url: "/courriers/ajaxformvalid/datereception",
                data: $('#CourrierSetInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
            });
        });
        $('#CourrierDate').change(function () {
            gui.request({
                url: "/courriers/ajaxformvalid/date",
                data: $('#CourrierSetInfosForm').serialize()
            }, function (data) {
                processJsonFormCheck(data);
            });
        });



        var getUpdate = false;
        if ($('#CourrierSoustypeId').val() != soutypeOrigine) {
            getUpdate = true;
        }
        gui.request({
            url: url,
            data: $('#CourrierSetInfosForm').serialize()
        }, function (data) {
            var update = $.parseJSON(data);
            if (getUpdate) {
                updateQualification(update.newCourrierSoustypeSens, update.newCourrierDelaiNb, update.newCourrierDelaiUnite);
                updateContextRight(update.newCourrierId);
                if( !fromdisp || hasInitRights ) {
                    getFlowControls();
                }
            }
            var d = new Date();
            $('#autoSaveInfo').html('Dernier enregistrement : ' + d.toLocaleTimeString());
            $('#autoSaveInfo').show();
            $('.msgChange').remove();
            $('.unitecreate').css('top', '-52px');
        });
    }

    function updateQualification(newCourrierSoustypeSens, newCourrierDelaiNb, newCourrierDelaiUnite) {
        if (newCourrierSoustypeSens != 'empty') {
            var direction = {
                "0": {
                    'img' : '<i class="fa fa-sign-out" style="color:#e51809;" aria-hidden="true"></i>',
                    'txt': '<?php echo __d('courrier', 'Courrier.courrier_sortant'); ?>',
                    'contact': 'dest'
                },
                '1': {
                    'img' : '<i class="fa fa-sign-in" style="color:#2ec07e;" aria-hidden="true"></i>',
                    'txt': '<?php echo __d('courrier', 'Courrier.courrier_entrant'); ?>',
                    'contact': 'exp'
                },
                '2': {
                    'img': '<?php echo $this->Html->image('/img/flux_interne.png'); ?>',
                    'txt': '<?php echo __d('courrier', 'Courrier.courrier_interne'); ?>',
                    'contact': 'exp'
                }
            }
            var newSens = direction[newCourrierSoustypeSens]['img'] + ' ' + direction[newCourrierSoustypeSens]['txt'];
            $('.fakeDisabledInputText').html('<span>' + newSens + '</span>');

            $('#CourrierEntrant').hide();

            $('#CourrierDelaiNb').val(newCourrierDelaiNb);
            $('#CourrierDelaiUnite').val(newCourrierDelaiUnite);
            $('#CourrierDelaiNb').hide();
            $('#CourrierDelaiUnite').parent().hide();
            $('.defautDelaiInfo').hide();
            tabDelaiUnite = {
                '0': 'jour',
                '1': 'semaine',
                '2': 'mois'
            };
            if ($('.updateParDefautDelaiInfo').length != 0) {
                $('.updateParDefautDelaiInfo').html('Par défaut ' + newCourrierDelaiNb + ' ' + tabDelaiUnite[newCourrierDelaiUnite] + 's');
            } else {
                $('<span class="form-control col-sm-5 updateParDefautDelaiInfo" >Par défaut ' + newCourrierDelaiNb + ' ' + tabDelaiUnite[newCourrierDelaiUnite] + 's</span>').insertBefore($('#CourrierDelaiNb'));
            }
        }
    }

    function updateContextRight(newCourrierId) {
        var url = window.location.href;
        var urlCouper = url.split('/');
        var desktopId = urlCouper[urlCouper.length - 1];
        gui.request({
            url: '/courriers/updateContext/' + newCourrierId + '/' + desktopId
        }, function (data) {
            $('#flux_context').html(data);
        });

    }

    $('#CourrierName').prop('spellcheck', true);
</script>

<?php } ?>