<?php

/**
 *
 * Desktops/edit.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
echo $this->Html->script('formValidate.js', array('inline' => true));
?>
<div class="panel panel-default zone-form" id="editRole">
    <div class="panel-heading">
        <h4 class="panel-title"><?php echo __d('desktop', 'Desktop.edit'); ?></h4>
    </div>
    <div class="panel-body">
        <?php
        $formDesktops = array(
            'name' => 'Desktop',
            'label_w' => 'col-sm-3',
            'input_w' => 'col-sm-6',
            'input' => array(
                'Desktop.id' => array(
                    'inputType' => 'hidden',
                    'items'=>array(
                        'type'=>'hidden'
                    )
                ),
                'Desktop.group_id' => array(
                    'labelText' =>__d('desktop', 'Desktop.group_id'),
                    'inputType' => 'select',
                    'items'=>array(
                        'required'=>true,
                        'type'=>'select',
                        'empty' => true,
                        'options' => $groups
                    )
                ),
                'Desktop.name' => array(
                    'labelText' =>__d('desktop', 'Desktop.name'),
                    'inputType' => 'text',
                    'items'=>array(
                        'type'=>'text',
                        'required'=>true/*,
                        'pattern'=>"^[_A-z0-9 ]{1,}$",
                        'data-error' => "Les caractères suivants ne sont pas autorisés (/[](){},$\_*+.]/' )"*/
                    )
                ),
                'Service.Service' => array(
                    'labelText' => 'services*',
                    'inputType' => 'select',
                    'items'=>array(
                        'type' => 'select',
                        'required'=>true,
                        'escape' => false,
                        'options' => $services,
                        'multiple' => true,
                        'default' => false,
                        'multiple' => 'multiple',
                        'class' => 'selectMultiple',
                    )
                )
            )
        );
        echo $this->Formulaire->createForm($formDesktops);
        echo $this->Form->end();
        ?>
    </div>
    <div class="panel-footer controls " role="group">
        <a class="btn btn-success " id="saveEditRole"><i class="fa fa-floppy-o" aria-hidden="true"></i> Enregistrer</a>
        <a class="btn btn-danger " id="cancel"><i class="fa fa-times-circle-o" aria-hidden="true"></i> Annuler</a>
    </div>
</div>
<script>
    // Mise en palce d'un select plus clair
    $('#ServiceService').select2({allowClear: true, placeholder: "Sélectionner un service"});
    $('#DesktopGroupId').select2({allowClear: true, placeholder: "Sélectionner un groupe"});
    var selectedOptionHtml = $('#DesktopGroupId option:selected').html();
    $('#DesktopGroupId').change(function () {
        swal({
            title: "<?php echo __d('desktop', 'Desktop.changeProfil.title'); ?>",
            text: "<?php echo __d('desktop', 'Desktop.changeProfil.msg'); ?>",
            type: "warning",
            timer: 1500
        });
        var newSelectedOptionHtml = $('#DesktopGroupId option:selected').html();
        $('#DesktopName').val($('#DesktopName').val().replace(selectedOptionHtml, newSelectedOptionHtml));
        selectedOptionHtml = newSelectedOptionHtml;
    }).blur(function () {
        if ($('#DesktopName').val() == '' && $('#DesktopGroupId').val() != '') {
            $('#DesktopName').val('<?php echo __d('desktop', 'Desktop.sccsq'); ?> ' + $('#DesktopGroupId option:selected').html());
            checkDesktopNameUnique($('#DesktopEditForm'));
        }
    });

    $('#DesktopName').blur(function () {
        checkDesktopNameUnique($('#DesktopEditForm'));
    });

    $('#saveEditRole').click(function () {
        if ($("#DesktopEditForm .errorJsonFormCheck").length == 0) {
            var id = <?php echo $id;?>;
            if (form_validate($('#DesktopEditForm'))) {
                gui.request({
                    url: '/desktops/edit/' + id,
                    data: $('#DesktopEditForm').serialize(),
                    loaderElement: $('.ui-dialog-content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                }, function (data) {
                    getJsonResponse(data);
                        $('.ui-dialog-content').html(data);
                        $('.loader').remove();
                });
                loadHabilis();
            } else {
                swal({
                    title: "Oops...",
                    text: "Veuillez vérifier votre formulaire!",
                    type: "error",
                    timer: 1500
                });
            }
        }
    });

    $('#cancel').click(function () {
        $("#editRole").remove();
        $("#habilsPerson").show();
    });


</script>